#include <iostream>
#include <vector>
#include <algorithm>
#include <ext/numeric>
#include <ext/algorithm>

int main()
{
    using namespace std; 
    const int N = 10000000;    // liczba losowa (= liczba wypenionych kuponw)
   
    vector<int> los(6);        // tu wpisujemy 6 ,,skrelonych" liczb
    vector<int> kupon(49);     // na kuponie do skrelenia jest 49 liczb
    vector<int> wynik(7);      // tu zapiszemy liczb trafionych trjek,...,szstek
    __gnu_cxx::iota(kupon.begin(), kupon.end(), 1); // inicjalizacja kuponu
   
    srand(time(0));            // inicjalizacja generatora liczb pseudolosowych
    for(int i = 0; i < N; ++i)
    {
        __gnu_cxx::random_sample(kupon.begin(), kupon.end(), los.begin(), los.end());
        int n = count_if(los.begin(), los.end(), bind2nd(std::less<int>(), 7));
        wynik[n]++;
    }
    for (int i = 3; i <= 6 ; i++)
        cout << "liczba trafien " << i << ": " << wynik[i] << "\n";
}

/*
liczba trafien 3: 176099
liczba trafien 4: 9501
liczba trafien 5: 202
liczba trafien 6: 3
*/
